// Routines to shift an unsigned int by any number of places.
//
// This is needed because using << or >> to shift a 32-bit quantity
// by an amount more than OR EQUAL TO 32 places
// gives an undefined result!!!!!  GRRR!!!!!
// Also using << or >> to shift a negative number of places
// gives an undefined result.

#include "shift.h"

// This is because for some reason the standard abs(int)
// is not of type "unsigned", which leads to gratuitous warnings.
unsigned Abs(const int foo){
  if (foo >= 0) return foo;
  return -foo;
}

unsigned Rsh(const unsigned num, const int places){
  if (Abs(places) >= 8*sizeof(num)) return 0;
  if (places < 0) return num << -places;
  return num >> places;
}

unsigned Lsh(const unsigned num, const int places){
  if (Abs(places) >= 8*sizeof(num)) return 0;
  if (places < 0) return num >> -places;
  return num << places;
}
